//+------------------------------------------------------------------+
//|                                                  STO_CCI_RSI.mq4 |                                   
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_color3 Yellow
#property indicator_color4 Red



//---- Ext parameters-----
extern int RSIPer=13;
extern int StochPer=8;
extern int Par3Per=8;
extern double Hot=0.4;
extern int smoothing=4;

//
double Signal1[],Signal2[],upX[],downX[];

//
int init()
{

	// to be optimized with  IndicatorShortName("STO_CCI_RSI ("+RSIPer+","+StochPer+","+Par3Per+","+Hot+","+smoothing+") "+TimeFrameStr); 
	
	string FileName;
	SetIndexStyle(0,DRAW_LINE);
	SetIndexStyle(1,DRAW_LINE);
	SetIndexBuffer(0,Signal1);
	SetIndexBuffer(1,Signal2);
	SetIndexStyle(2,DRAW_ARROW);
	SetIndexArrow(2,159);
	SetIndexBuffer(2,upX);
	SetIndexStyle(3,DRAW_ARROW);
	SetIndexArrow(3,159);
	SetIndexBuffer(3,downX);

	SetIndexDrawBegin(0,RSIPer+StochPer+Par3Per+Hot+smoothing);
	SetIndexDrawBegin(1,RSIPer+StochPer+Par3Per+Hot+smoothing);
	SetIndexDrawBegin(2,RSIPer+StochPer+Par3Per+Hot+smoothing);
	SetIndexDrawBegin(3,RSIPer+StochPer+Par3Per+Hot+smoothing);

	return(0);
}

int start()
{
	int i,i2,counted_bars= IndicatorCounted();
	
	double rsi,maxrsi,minrsi,storsi,SCR,sig1,sig2,sk,Sm,sk2;
	double cs;
	
	bool init=true;

	cs= RSIPer+StochPer+Par3Per+Hot+smoothing;
	if(Bars<=cs) return(0);

	Sm=smoothing;
	if (Sm<2) Sm=2;
	sk = 2 / (Sm + 1);
	sk2=2/(Sm*0.8+1);
	
	init=false;

	//
	
	if(counted_bars<1)
	{
		for(i=1;i<=cs;i++) Signal1[Bars-i]=0.0;
		for(i=1;i<=cs;i++) Signal2[Bars-i]=0.0;
		for(i=1;i<=cs;i++) upX[Bars-i]=0.0;
		for(i=1;i<=cs;i++) downX[Bars-i]=0.0;
	}
	
	i=Bars-cs-1;

	if (counted_bars>=cs) i=200; 
	while (i>=0)
	{
		rsi= iRSI(NULL,0,RSIPer,PRICE_CLOSE,i);
		maxrsi=rsi;
		minrsi=rsi;

		for (i2=i+StochPer;i2>=i; i2--)
		{
			rsi= iRSI(NULL,0,RSIPer,PRICE_CLOSE,i2);
			if (rsi>maxrsi) maxrsi=rsi;
			if (rsi<minrsi) minrsi=rsi;
		}
		
		storsi=((rsi-minrsi)/(maxrsi-minrsi)*200-100);
		
		SCR= Hot*iCCI(NULL,0,Par3Per,PRICE_TYPICAL,i)+(1-Hot)*storsi;
		
		Signal1[i]=sk*SCR+(1-sk)*sig1;
		Signal2[i]=sk2*sig1+(1-sk2)*sig2;
		
		sig1=Signal1[i];
		sig2=Signal2[i];
		
		if (Signal1[i]>Signal2[i] && Signal1[i+1]<Signal2[i+1]) upX[i]=Signal2[i]-15;
		if (Signal1[i]<Signal2[i] && Signal1[i+1]>Signal2[i+1]) downX[i]=Signal2[i]+15;

		i--;
	}
	
	return(0);
}
//+--------------------------------------------------------------------------------------+




